/*
*
*/

// OSC messages
OscIn oin;
8338 => oin.port;
OscMsg msg;
oin.listenAll();


// Sound file
SndBuf buf => dac;

48000 => int SAMPLE_RATE;

fun void printArgs( OscMsg msg )
{
    // iterate over
    for( int i; i < msg.numArgs(); i++ )
    {
        if( msg.typetag.charAt(i) == 'f' ) // float
        {
            cherr <= msg.getFloat(i) <= " ";
        }
        else if( msg.typetag.charAt(i) == 'i' ) // int
        {
            cherr <= msg.getInt(i) <= " ";
        }
        else if( msg.typetag.charAt(i) == 's' ) // string
        {
            cherr <= msg.getString(i) <= " ";
        }            
    }       
    
    // new line
    cherr <= IO.newline();
}


0 => int PLAY_TIME;

fun void play() {
    while (true) {
        <<<PLAY_TIME>>>;
        if (PLAY_TIME != 0) {
            (PLAY_TIME * 1000)::ms => now;
        }
    }
}

fun void recv_msg() {
    
}


// spork ~play();
// spork ~recv_msg();


// time loop
while( true )
{   
    while (oin.recv(msg)) {  
        cherr <= "RECEIVED: \"" <= msg.address <= "\": "; 
        printArgs( msg );
        msg.getString(3) => string filename;
        filename => buf.read;

        msg.getString(0) => string lyric;
        msg.getInt(1) => int pos;
        msg.getInt(2) => int play_len;
 
        pos * SAMPLE_RATE / 1000 => buf.pos;
        0.5 => buf.gain;
        play_len => PLAY_TIME;
    }
    PLAY_TIME::ms => now;
    1000 => PLAY_TIME;
    0 => buf.gain;
}