import os
from .neural_worker import NeuralWorker


def write_back_chat(filename, input, reply):
    with open(filename, "r+", encoding = "utf-8") as file:
        file.seek(0, os.SEEK_END)

        pos = file.tell() - 1

        while pos > 0 and file.read(1) != "\n":
            pos -= 1
            file.seek(pos, os.SEEK_SET)

        if pos > 0:
            file.seek(pos, os.SEEK_SET)
            file.truncate()
        
        file.write("\nMe: " + input + '\n')
        file.write("GPT: " + reply + '\n')
        file.write("Me: {history}")


def gen_chat_reply(input, prompt_file, args):
    """
    Use GPT-3 to generate alternative questions
    """
    neural_worker = NeuralWorker(prompt_template_file=prompt_file, engine=args.engine)

    filled_prompt = neural_worker.fill_prompt_template(history=input)
    reply = neural_worker.generate(input_text=filled_prompt, args=args, postprocess=True, max_tries=1)

    # write_back_chat(prompt_file, input, reply)

    return reply