import os
import requests


def query(payload):
    API_URL = "https://api-inference.huggingface.co/models/sentence-transformers/all-MiniLM-L6-v2"
    headers = {"Authorization": f"Bearer {os.environ.get('HUGGINGFACE_API_KEY')}"}

    response = requests.post(API_URL, headers=headers, json=payload)
    return response.json()

def semantic_sim(source, sentences):
    data = query(
        {
            "inputs": {
                "source_sentence": source,
                "sentences": sentences
            }
        })
    
    max_val = max(data)
    max_idx = data.index(max_val)
    return max_idx